%define _enable_debug_packages %{nil}
%define debug_package          %{nil}


# THIS PACKAGE IS STORED IN SVN
# PLEASE DO NOT UPLOAD WITHOUT
# COMMITTING YOUR CHANGES FIRST

%define version 2004g
%define fversion 2004g
%define release %mkrel 5
%define fname imap

%define soname c-client-php
%define major 0
%define libname %mklibname %{soname} %{major}

# Change the default connected directory from the user's home directory
# to the named subdirectory of the user's home directory
%define	mailsubdir Mail

%define name imap
%define	renamed_uw 0
%define with_krb 1

Summary:	Server daemons for IMAP and POP network mail protocols
Name:		%{fname}
Version:	%{version}
Release:	%{release}
License:	BSD
Group:		System/Servers
Source:		ftp://ftp.cac.washington.edu/mail/imap-%{fversion}.tar.Z
Source2:	imap-xinetd
Source3:	ipop3-xinetd
Source4:	ipop2-xinetd
Source5:	imaps-xinetd
Source6:	pop3s-xinetd
Source7:	flock.c
Source8:	Makefile.imap
Source9:	ftp://ftp.cac.washington.edu/mail/imap-utils.tar.bz2

Patch0: 	imap-2002e-ssl.patch
Patch1: 	imap-2004d-linux.diff
Patch3:		imap-2001a-disable-mbox.patch
Patch4:		imap-2001a-redhat.patch
Patch5: 	imap-2004-flock.diff
Patch7: 	imap-2004c1-version.diff
Patch9:		imap-2004-glibc-2.2.2.diff
Patch11:	imap-2002-krbpath.patch
Patch12:	imap-2001a-overflow.patch
Patch15:	imap-2002a-noprompt-makefile.patch
Patch16:	imap-utils-makefiles.patch
Patch17:	imap-2002d-mail-spool-perms.patch
Patch21:	imap-2004a-shared.patch
Patch22:	imap-2002e-authmd5.patch
Patch23:	imap-2004e-annotate.diff
Patch24:	imap-2004g-hash_reset.diff
BuildRoot:	%{_tmppath}/%{name}-buildroot
Requires:	pam >= 0.59
PreReq:		xinetd
BuildPreReq:	openssl-devel
%if %{with_krb}
BuildPreReq:	krb5-devel
%endif
BuildRequires:	pam-devel
URL:		http://www.washington.edu/imap/
Conflicts:	cyrus-imapd courier-imap

%if %{renamed_uw}
Provides:	imap = %{version}
Obsoletes:	imap
%endif

%description
The imap package provides server daemons for both the IMAP (Internet
Message Access Protocol) and POP (Post Office Protocol) mail access
protocols.  The POP protocol uses a "post office" machine to collect mail
for users and allows users to download their mail to their local machine
for reading. The IMAP protocol provides the functionality of POP, but
allows a user to read mail on a remote machine without downloading it to
their local machine.

Install the imap package if you need a server to support the IMAP or the
POP mail access protocols.

%package	devel
Summary:	Libraries, includes, etc to develop IMAP applications
Group:		Development/C
%if %{renamed_uw}
Provides:       imap-devel = %{version}
Obsoletes:      imap
%endif

%description	devel
The imap-devel package contains the header files and static libraries for
developing programs which will use the IMAP (Internet Message Access
Protocol) library.

%package	utils
Summary:	Some basic IMAP utilities to make managing your email simpler
Group:		System/Servers
%if %{renamed_uw}
Provides:       imap-utils = %{version}
Obsoletes:      imap
%endif

%description	utils
This package contains some basic IMAP tools for managing IMAP email.

These tools are part of the uw-imapd, but may be used indepentantly
since they are stand-alone and not bound to a specific IMAP server.

chkmail  - check for new mail
icat     - "cat" a mailbox from an IMAP source (standard Unix mailbox format)
ifrom    - one line per message summary of IMAP mailbox

imapcopy - copy messages from an IMAP inbox to a local mailbox
imapmove - move messages from an IMAP inbox to a local mailbox
imapxfer - copy mailboxes between IMAP servers

mbxcreat - create a new mailbox
mbxcopy  - copy messages to a new mailbox
mbxmove  - move messages to a new mailbox
mbxcvt   - copy or move messages to a new mailbox, converting mailbox format

dmail    - procmail Mail Delivery Module
tmail    - Mail Delivery Module

%package -n	%{libname}
Summary:	C-client mail access routines for IMAP and POP protocols
Group:		System/Libraries
Provides:	c-client

%description -n	%{libname}
C-client is a common API for accessing mailboxes. It is used internally by
the popular PINE mail reader, the University of Washington's IMAP server
and PHP.

This package contains the shared c-client library.

%package -n	%{libname}-devel
Summary:	Development files for the c-client library
Group:		Development/C
Provides:	libc-client-php-devel
Requires:	%{libname} = %{version}
Requires:	imap-devel = %{version}

%description -n	%{libname}-devel
C-client is a common API for accessing mailboxes. It is used internally by
the popular PINE mail reader, the University of Washington's IMAP server
and PHP.

This package contains development files for the c-client library.

%prep

%setup -q -n %{fname}-%{fversion} -a9

# (sb) breaks patching
rm -rf RCS

%patch0 -p0 -b .ssl
%patch1 -p0 -b .linux
%patch3 -p1 -b .mbox
%patch4 -p1 -b .redhat
%patch5 -p0 -b .flock
%patch7 -p1 -b .version
install -m 0644 %{SOURCE7} src/osdep/unix/flock.c
%patch9 -p1 -b .glibc
%if %with_krb
%patch11 -p1 -b .gssapi-patch
%endif

%patch12 -p1 -b .overflow
%patch15 -p1 -b .noprompt
%patch16 -p1 -b .utils
%patch17 -p1 -b .lock-warning
%patch21 -p1 -b .shared
%patch22 -p1 -b .authmd5
%patch23 -p1 -b .annotate
%patch24 -p1 -b .hash_reset

# save man pages, since main Makefile overwrites these directories
mv tmail/tmail.1 .
mv dmail/dmail.1 .

install -m 0644 %{SOURCE2} imap-xinetd
install -m 0644 %{SOURCE3} ipop3-xinetd
install -m 0644 %{SOURCE4} ipop2-xinetd
install -m 0644 %{SOURCE5} imaps-xinetd
install -m 0644 %{SOURCE6} pop3s-xinetd

%build
EXTRACFLAGS="$EXTRACFLAGS -I%{_includedir}/openssl"
%if %with_krb
EXTRACFLAGS="$EXTRACFLAGS -I%{_includedir}/krb5"
%endif
EXTRALDFLAGS="$EXTRALDFLAGS -L%{_libdir}"

%make RPM_OPT_FLAGS="%{optflags} -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer" lnp \
	EXTRACFLAGS="$EXTRACFLAGS" \
	EXTRALDFLAGS="$EXTRALDFLAGS" \
%if %{with_krb}
	EXTRAAUTHENTICATORS=gss \
%endif
	SSLDIR=%{_libdir}/ssl \
	SSLINCLUDE=%{_includedir}/openssl \
	SSLLIB=%{_libdir} \
	LOCKPGM=%{_sbindir}/mlock \
	SSLTYPE=unix.nopwd \
	BASECFLAGS="%{optflags} -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer" \
	IP=6

mv -f ipopd/ipop3d ipop3sd
mv -f imapd/imapd imapsd
mv -f c-client/c-client.a c-client-ssl.a
make clean

################################################################################
# Build a usable c-client.a for PHP4 (duh!) // Oden Eriksson Tue 15 Jun 2004
# Thanks to Troels Arvin <troels@arvin.dk> and Kaj J. Niemi for he hints!
EXTRACFLAGS="$EXTRACFLAGS -DDISABLE_POP_PROXY=1 -DIGNORE_LOCK_EACCES_ERRORS=1"
EXTRACFLAGS="$EXTRACFLAGS -I%{_includedir}/openssl"
EXTRALDFLAGS="$EXTRALDFLAGS -L%{_libdir}"

make RPM_OPT_FLAGS="%{optflags} -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer" slx \
	EXTRACFLAGS="$EXTRACFLAGS" \
	EXTRALDFLAGS="$EXTRALDFLAGS" \
	SSLDIR=%{_libdir}/ssl \
	SSLINCLUDE=%{_includedir}/openssl \
	SSLLIB=%{_libdir} \
	LOCKPGM=%{_sbindir}/mlock \
	SSLTYPE=unix \
	SHLIBBASE=%{soname} \
	SHLIBNAME=lib%{soname}.so.%{major} \
	BASECFLAGS="%{optflags} -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer" \
	IP=6

mv -f c-client/c-client.a %{soname}.a
mv -f c-client/lib%{soname}.so.%{major} .
make clean

################################################################################
# rebuild without SSL support to allow using of different (imapd/imapsd, ipop3d/ipop3sd)
# libwrapper entries.
%make RPM_OPT_FLAGS="%{optflags} -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer" lnp \
	EXTRACFLAGS="$EXTRACFLAGS" \
	LOCKPGM=%{_sbindir}/mlock \
	SSLTYPE=none \
	BASECFLAGS="%{optflags} -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer" \
	IP=6

cp -p c-client/c-client.a c-client-nossl.a

# build imap-utils
for i in chkmail icat ifrom imapcopy imapxfer mbxcopy mbxcreat mbxcvt ; do
  %make -C $i
done

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# make some directories
install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}%{_sysconfdir}/xinetd.d
install -d %{buildroot}%{_sysconfdir}/ssl/imap
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_includedir}/imap
install -d %{buildroot}%{_localstatedir}/imap/ssl
install -d %{buildroot}%{_mandir}/man8
install -d %{buildroot}%{_mandir}/man1

# install man pages
install -m0644 chkmail/chkmail.1 %{buildroot}%{_mandir}/man1/
install -m0644 dmail.1 %{buildroot}%{_mandir}/man1/
install -m0644 icat/icat.1 %{buildroot}%{_mandir}/man1/
install -m0644 ifrom/ifrom.1 %{buildroot}%{_mandir}/man1/
install -m0644 imapcopy/imapcopy.1 %{buildroot}%{_mandir}/man1/
install -m0644 imapxfer/imapxfer.1 %{buildroot}%{_mandir}/man1/
install -m0644 mbxcopy/mbxcopy.1 %{buildroot}%{_mandir}/man1/
install -m0644 mbxcreat/mbxcreat.1 %{buildroot}%{_mandir}/man1/
install -m0644 mbxcvt/mbxcvt.1 %{buildroot}%{_mandir}/man1/
install -m0644 tmail.1 %{buildroot}%{_mandir}/man1/
install -m0644 src/imapd/imapd.8 %{buildroot}%{_mandir}/man8/imapd.8
install -m0644 src/ipopd/ipopd.8 %{buildroot}%{_mandir}/man8/ipopd.8

# install daemons
install -m0755 ipopd/ipop2d %{buildroot}%{_sbindir}/
install -m0755 ipopd/ipop3d %{buildroot}%{_sbindir}/
install -m0755 imapd/imapd %{buildroot}%{_sbindir}/
install -m0755 ipop3sd %{buildroot}%{_sbindir}/
install -m0755 imapsd %{buildroot}%{_sbindir}/

# install utils
install -m0755 chkmail/chkmail %{buildroot}%{_bindir}/
install -m0755 dmail/dmail %{buildroot}%{_bindir}/
install -m0755 icat/icat %{buildroot}%{_bindir}/
install -m0755 ifrom/ifrom %{buildroot}%{_bindir}/
install -m0755 imapcopy/imapcopy %{buildroot}%{_bindir}/
ln -snf imapcopy %{buildroot}%{_bindir}/imapmove
install -m0755 imapxfer/imapxfer %{buildroot}%{_bindir}/
install -m0755 mbxcopy/mbxcopy %{buildroot}%{_bindir}/
ln -snf mbxcopy %{buildroot}%{_bindir}/mbxmove
install -m0755 mbxcreat/mbxcreat %{buildroot}%{_bindir}/
install -m0755 mbxcvt/mbxcvt %{buildroot}%{_bindir}/
install -m0755 tmail/tmail %{buildroot}%{_bindir}/

# install pam files
%if %mdkversion < 200700
cat > %{buildroot}%{_sysconfdir}/pam.d/imap <<EOF
#%PAM-1.0
auth       required     pam_stack.so service=system-auth
account    required     pam_stack.so service=system-auth
EOF
%else
cat > %{buildroot}%{_sysconfdir}/pam.d/imap <<EOF
#%PAM-1.0
auth       include     system-auth
account    include     system-auth
EOF
%endif
cp -a %{buildroot}%{_sysconfdir}/pam.d/{imap,pop}

# install headers
install -m0644 c-client/*.h %{buildroot}%{_includedir}/imap/
install -m0644 src/osdep/tops-20/shortsym.h %{buildroot}%{_includedir}/imap/

# install static libraries
install -m0644 c-client-nossl.a %{buildroot}%{_libdir}/libc-client-nossl.a
install -m0644 c-client-ssl.a %{buildroot}%{_libdir}/libc-client.a
# rh - Added linkage.c to fix (#34658) <mharris>
install -m0644 c-client/linkage.c %{buildroot}%{_includedir}/imap/

# install xinetd scripts
install -m0644 imap-xinetd %{buildroot}%{_sysconfdir}/xinetd.d/imap
install -m0644 ipop3-xinetd %{buildroot}%{_sysconfdir}/xinetd.d/ipop3
install -m0644 ipop2-xinetd %{buildroot}%{_sysconfdir}/xinetd.d/ipop2
install -m0644 imaps-xinetd %{buildroot}%{_sysconfdir}/xinetd.d/imaps
install -m0644 pop3s-xinetd %{buildroot}%{_sysconfdir}/xinetd.d/pop3s

# SSL support
# Generate ghost *.pem files
touch %{buildroot}%{_sysconfdir}/ssl/imap/{imapsd,ipop3sd}.pem
chmod 600 %{buildroot}%{_sysconfdir}/ssl/imap/{imapsd,ipop3sd}.pem
# install the RedHat Makefile
install -m 0644 %{SOURCE8} %{buildroot}%{_localstatedir}/imap/ssl/Makefile.imap
# (sb) moved the above Makefile to make rpmlint happy
ln -sf %{_localstatedir}/imap/ssl/Makefile.imap %{buildroot}%{_sysconfdir}/ssl/imap/

# mailsubdir
cat > %{buildroot}%{_sysconfdir}/c-client.cf <<EOF
I accept the risk of using UW-imapd
set mail-subdirectory %mailsubdir
EOF

# OE: 20040614 provide stuff for php
install -m0755 lib%{soname}.so.%{major} %{buildroot}%{_libdir}/
ln -snf lib%{soname}.so.%{major} %{buildroot}%{_libdir}/lib%{soname}.so
install -m0755 %{soname}.a %{buildroot}%{_libdir}/lib%{soname}.a

%post
# If no cert, migrate stunnel.pem, or generate a new cert
pushd %{_sysconfdir}/ssl/imap &> /dev/null || :
for CERT in imapsd.pem ipop3sd.pem ;do
   if [ ! -e $CERT ];then
      if [ -e stunnel.pem ];then
         cp stunnel.pem $CERT &> /dev/null || :
      elif [ -e Makefile.imap ];then
         make -f Makefile.imap $CERT << EOF &> /dev/null || :
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
localhost.localdomain
root@localhost.localdomain
EOF
      fi
   fi
done
popd &> /dev/null || :
[ -x /etc/init.d/xinetd ] && /etc/init.d/xinetd condrestart 2>/dev/null >/dev/null
exit 0

%postun
[ -x /etc/init.d/xinetd ] && /etc/init.d/xinetd condrestart 2>/dev/null >/dev/null
exit 0

%triggerpostun -- imap < 1:2002d-6mdk
if [ -r %{_sysconfdir}/c-client.cf ]; then
	if grep -q "^set mail-subdirectory %mailsubdir" %{_sysconfdir}/c-client.cf; then
		perl -pi -e 's/^set mail-subdirectory/\#set mail-subdirectory/g' \
			%{_sysconfdir}/c-client.cf
	fi
fi

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/xinetd.d/ipop2
%config(noreplace) %{_sysconfdir}/xinetd.d/ipop3
%config(noreplace) %{_sysconfdir}/xinetd.d/pop3s
%config(noreplace) %{_sysconfdir}/xinetd.d/imap
%config(noreplace) %{_sysconfdir}/xinetd.d/imaps
%config(noreplace) %{_sysconfdir}/pam.d/imap
%config(noreplace) %{_sysconfdir}/pam.d/pop
%dir %{_sysconfdir}/ssl/imap
%attr(0600,root,root) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sysconfdir}/ssl/imap/*.pem
%{_sysconfdir}/ssl/imap/Makefile.imap
%dir %{_localstatedir}/imap
%{_localstatedir}/imap/ssl/Makefile.imap
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/c-client.cf
%{_mandir}/man8/ipopd.8*
%{_mandir}/man8/imapd.8*
%attr(0755,root,mail) %{_sbindir}/ipop2d
%attr(0755,root,mail) %{_sbindir}/ipop3d
%attr(0755,root,mail) %{_sbindir}/ipop3sd
%attr(0755,root,mail) %{_sbindir}/imapd
%attr(0755,root,mail) %{_sbindir}/imapsd
%doc README CPYRIGHT
%doc `find docs -type f | grep -v internal.txt` 

%files utils
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/chkmail
%attr(0755,root,root) %{_bindir}/dmail
%attr(0755,root,root) %{_bindir}/icat
%attr(0755,root,root) %{_bindir}/ifrom
%attr(0755,root,root) %{_bindir}/imapcopy
%attr(0755,root,root) %{_bindir}/imapmove
%attr(0755,root,root) %{_bindir}/imapxfer
%attr(0755,root,root) %{_bindir}/mbxcopy
%attr(0755,root,root) %{_bindir}/mbxmove
%attr(0755,root,root) %{_bindir}/mbxcreat
%attr(0755,root,root) %{_bindir}/mbxcvt
%attr(0755,root,root) %{_bindir}/tmail
%attr(0644,root,root) %{_mandir}/man1/chkmail.1*
%attr(0644,root,root) %{_mandir}/man1/dmail.1*
%attr(0644,root,root) %{_mandir}/man1/icat.1*
%attr(0644,root,root) %{_mandir}/man1/ifrom.1*
%attr(0644,root,root) %{_mandir}/man1/imapcopy.1*
%attr(0644,root,root) %{_mandir}/man1/imapxfer.1*
%attr(0644,root,root) %{_mandir}/man1/mbxcopy.1*
%attr(0644,root,root) %{_mandir}/man1/mbxcreat.1*
%attr(0644,root,root) %{_mandir}/man1/mbxcvt.1*
%attr(0644,root,root) %{_mandir}/man1/tmail.1*

%files devel
%defattr(-,root,root)
%doc docs/internal.txt
%{_libdir}/libc-client.a
%{_libdir}/libc-client-nossl.a
%{_includedir}/imap

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/lib%{soname}.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%{_libdir}/lib%{soname}.a
%{_libdir}/lib%{soname}.so



%changelog
* Mon Dec 30 2013 bb <bb> 2004g-5pclos2013
- rebuild

* Thu Aug 23 2007 Texstar <texstar@gmail.com> 
- bug fix update to inetd files

* Thu Oct 26 2006 Texstar <texstar@houston.rr.com>
- initial build for pclinuxos 2007
